export interface CacheSaveEntry<T> {
    timestamp: Date;
    content: T;
}
export interface CacheLoadResult<T> extends CacheSaveEntry<T> {
    exists: boolean;
}
export interface Cache {
    save(content: any, timestamp: Date, id: number, category: string, subName?: string): Promise<void>;
    load(id: number, category: string, subName?: string): Promise<CacheLoadResult<any>>;
}
export declare function createCache(cacheRoot: string): Cache;
