import { Cache } from './cache';
import * as Wrapped from './github';
export declare type IssuePageFetchResult = {
    issues: GitHubAPI.Issue[];
    fetchMore?: () => Promise<IssuePageFetchResult>;
};
export declare function initialize(_oauthToken: string, _cache: Cache): void;
export declare function getMyLogin(): Promise<Wrapped.User>;
export declare function addLabels(issue: Wrapped.Issue, labels: string[]): Promise<void>;
export declare function removeLabels(issue: Wrapped.Issue, labels: string[]): Promise<void>;
export declare function setLabels(issue: Wrapped.Issue, labels: string[]): Promise<void>;
export declare function fetchIssueComments(issue: Wrapped.Issue): Promise<GitHubAPI.IssueComment[]>;
export declare function lockIssue(issue: Wrapped.Issue): Promise<void>;
export declare function unlockIssue(issue: Wrapped.Issue): Promise<void>;
export declare function closeIssue(issue: Wrapped.Issue): Promise<void>;
export declare function reopenIssue(issue: Wrapped.Issue): Promise<void>;
export declare function addComment(issue: Wrapped.Issue, body: string): Promise<void>;
export declare function editComment(comment: Wrapped.IssueComment, body: string): Promise<void>;
export declare function fetchChangedIssues(repo: GitHubAPI.RepoReference, opts?: {
    since?: Date;
    page?: number;
}): Promise<{
    issues: Wrapped.Issue[];
    fetchMore: undefined;
}>;
export declare function exec(method: string, path: string, queryString?: {
    [key: string]: string;
}, body?: string | undefined): Promise<string>;
