/// <reference path="github-api.ts" />
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Actions = require("./action");
exports.Actions = Actions;
const client = require("./client");
const cache_1 = require("./cache");
const actionRunner_1 = require("./actionRunner");
var github_1 = require("./github");
exports.User = github_1.User;
exports.Issue = github_1.Issue;
exports.Milestone = github_1.Milestone;
exports.Label = github_1.Label;
var pools_1 = require("./pools");
exports.Users = pools_1.Users;
exports.Issues = pools_1.Issues;
function bot(repoOwner, repoName, opts, oauthToken) {
    const cache = cache_1.createCache(opts.cacheRoot);
    client.initialize(oauthToken, cache);
    function updateCache() {
        return __awaiter(this, void 0, void 0, function* () {
            // TODO: Figure something out
        });
    }
    function runRules() {
        return __awaiter(this, void 0, void 0, function* () {
            const ruleNames = Object.keys(opts.rules);
            const info = {
                log: {}
            };
            for (const repo of opts.repos) {
                console.log(`Running ${Object.keys(opts.rules).length} rules on ${repo.owner}/${repo.name}`);
                console.log('Fetching repo activity');
                let page = 0;
                const issueResults = yield client.fetchChangedIssues(repo, { page });
                for (const issue of issueResults.issues) {
                    for (const ruleName of ruleNames) {
                        const rule = opts.rules[ruleName];
                        console.log(`Inovking rule ${ruleName} on ${issue.number}`);
                        const result = rule(issue);
                        if (result !== undefined) {
                            yield result;
                        }
                        console.log('... done');
                    }
                    yield actionRunner_1.runActions(info, opts);
                }
            }
        });
    }
    return ({
        runRules,
        updateCache
    });
}
exports.default = bot;
