"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const weak_string_map_1 = require("./weak-string-map");
class Pool {
    constructor(settings) {
        this.settings = settings;
        this.pool = new weak_string_map_1.default();
    }
    get(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const keyString = this.settings.keyToString(key);
            const extant = this.pool.get(keyString);
            if (extant) {
                return extant;
            }
            const data = yield this.settings.fetchData(key);
            return this.instantiate(data);
        });
    }
    instantiate(data, extra) {
        const key = this.settings.keyToString(this.settings.keyOf(data));
        const extant = this.pool.get(key);
        if (extant !== undefined) {
            return extant;
        }
        const newObj = new (this.settings.constructor)(data, extra);
        this.pool.set(key, newObj);
        return newObj;
    }
}
exports.Pool = Pool;
